# Chebyshev Interpolation
def chebexp(y):
    # Polynomgrad
    n = y.shape[0] - 1
    # RHS Vektor
    t = arange(0, 2*n+2)
    z = exp(-pi*1.0j*n/(n+1.0)*t) * hstack([y,y[::-1]])
    # Loese lineares System
    c = ifft(z)
    # Berechne b_j
    t = arange(-n, n+2)
    b = real(exp(0.5j*pi/(n+1.0)*t) * c)
    # Berechne a_j
    a = hstack([ b[n], 2*b[n+1:2*n+1] ])
    return a
